/usr/bin/lxc-test-snapdeps is in lxc-tests 2.0.7-0ubuntu1~16.04.2.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 | #!/bin/bash
# lxc: linux Container library
# Authors:
# Serge Hallyn <serge.hallyn@ubuntu.com>
#
# This is a test for dependency between snapshots
#
# When container c2 is created as an overlayfs clone of c1, then
# we record it as such, because c1 cannot be deleted until c2 is
# deleted. Once c2 is deleted, c1 should be delete-able.
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
# This test assumes an Ubuntu host
set -e
if ! grep -q overlay /proc/filesystems; then
echo "Not running this test as overlay is not available"
exit 0
fi
cleanup() {
for i in `seq 1 20`; do
lxc-destroy -n snapdeptest$i > /dev/null 2>&1 || true
done
lxc-destroy -n snapdeptest > /dev/null 2>&1 || true
}
verify_deps() {
n=$1
m=`wc -l /var/lib/lxc/snapdeptest/lxc_snapshots | awk '{ print $1 }'`
[ $((n*2)) -eq $m ]
}
cleanup
trap cleanup EXIT SIGHUP SIGINT SIGTERM
lxc-create -t busybox -n snapdeptest
lxc-copy -s -n snapdeptest -N snapdeptest1
fail=0
lxc-destroy -n snapdeptest || fail=1
if [ $fail -eq 0 ]; then
echo "FAIL: clone did not prevent deletion"
false
fi
for i in `seq 2 20`; do
lxc-copy -s -n snapdeptest -N snapdeptest$i
done
verify_deps 20
lxc-destroy -n snapdeptest1
verify_deps 19
lxc-destroy -n snapdeptest20
verify_deps 18
for i in `seq 2 19`; do
lxc-destroy -n snapdeptest$i
done
lxc-destroy -n snapdeptest
echo "Snapshot clone dependency test passed"
exit 0
|